Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## oracle.ifs.beans.parsers
Class IfsSimpleXmlParser

    java.lang.Object
      oracle.ifs.beans.parsers.IfsSimpleXmlParser

All Implemented Interfaces:
  XmlParserInterface

    public class IfsSimpleXmlParser

extends java.lang.Object
implements XmlParserInterface

The IfsSimpleXmlParser creates LibraryObjects by traversing the DOM tree.

The parser defines a simple mapping between XML tags and iFS objects.

The parser is the reverse of the SimpleXmlRenderer. Output from the SimpleXmlRenderer can be run through the IfsSimpleXmlParser to re-create the relevant objects.

(Unpublished)

Field Summary
`static java.lang.String` | `ACCESS_LEVEL_TAG`
`static java.lang.String` | `ACES_TAG`
`static java.lang.String` | `ACTION_ATTRIBUTE`
`static java.lang.String` | `ADD_ACTION`
`static java.lang.String` | `ARRAY_ELEMENT_TAG`
`static java.lang.String` | `ATTRIBUTES_TAG`
`static java.lang.String` | `CATEGORIES_TAG`
`static java.lang.String` | `CLASSNAME_ATTRIBUTE`
`static java.lang.String` | `CONTENT_TAG`
`static java.lang.String` | `DATATYPE_ATTRIBUTE`
`static java.lang.String` | `DATATYPE_TAG`
`static java.lang.String` | `DEFINITION_ATTRIBUTE`
`static java.lang.String` | `DOMAINTYPE_ATTRIBUTE`
`static java.lang.String` | `FOLDER_PATH_TAG`
`static java.lang.String` | `FORMAT_ATTRIBUTE`
`static java.lang.String` | `FORMAT_TAG`
`static java.lang.String` | `GRANTEE_TAG`
`static java.lang.String` | `IGNORE_UNSETTABLE_OPTION` If set to true in options table, parser will ignore all attributes in the XML document which are marked as "unsettable".
`protected java.lang.String` | `m_CharacterEncoding` The character encoding information stored in
`protected java.io.InputStream` | `m_InputStream` The InputStream representing the XML document
`protected IfsXmlParser` | `m_Parser` The IfsXmlParser
`protected java.io.Reader` | `m_Reader` The Reader representing the XML document
`protected LibrarySession` | `m_Session` The LibrarySession which constructed this XmlParser
`static java.lang.String` | `MEDIA_TAG`
`static java.lang.String` | `MEMBERS_TAG`
`static java.lang.String` | `OBJECT_LIST_TAG`
`static java.lang.String` | `OPTIONS_TAG`
`static java.lang.String` | `PASSWORD_TAG`
`static java.lang.String` | `PERMISSIONBUNDLES_TAG`
`static java.lang.String` | `POLICIES_TAG`
`static java.lang.String` | `POLICY_TAG`
`static java.lang.String` | `PROPERTIES_TAG`
`static java.lang.String` | `PROPERTY_VALUE_TAG`
`static java.lang.String` | `REFERENCE_BY_EXISTING`
`static java.lang.String` | `REFERENCE_BY_ID`
`static java.lang.String` | `REFERENCE_BY_NAME`
`static java.lang.String` | `REFERENCE_BY_PATH`
`static java.lang.String` | `REFERENCE_BY_VALUEDEFAULT`
`static java.lang.String` | `REFERENCE_TYPE_ATTRIBUTE`
`static java.lang.String` | `REMOVE_ACTION`
`static java.lang.String` | `SIMPLE_USER_TAG`
`static java.lang.String` | `UPDATE_TAG`
`static java.lang.String` | `VALUEDEFAULT_VALUE_TAG`
`static java.lang.String` | `VALUEDOMAIN_VALUE_TAG`

Constructor Summary
`IfsSimpleXmlParser(LibrarySession session)` Constructs a IfsSimpleXmlParser

Method Summary
`protected SimpleXmlParserImpl` | `getImplementation(ParserCallback callback, java.util.Hashtable options)` Creates a SimpleXmlParserImpl to parse the document with.
`protected LibraryObjectDefinition` | `handleUnknownTag(org.w3c.dom.Element unknownElement, LibraryObjectDefinition lod)` Handles an unknown tag.
`LibraryObject` | `parse(IfsXmlParser ifsxmlparser, java.io.InputStream stream, ParserCallback callback, java.util.Hashtable options)` Parses the specified InputStream representing an XML document.
`LibraryObject` | `parse(IfsXmlParser ifsxmlparser, java.io.Reader reader, ParserCallback callback, java.util.Hashtable options)` Parses the specified Reader representing an XML document.
`protected LibraryObject` | `traverseTree(oracle.xml.parser.v2.XMLDocument doc, ParserCallback callback, java.util.Hashtable options)` Traverses the DOM tree and creates the appropriate LibraryObjects.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### IGNORE_UNSETTABLE_OPTION

    public static final java.lang.String IGNORE_UNSETTABLE_OPTION

  Description copied from class: `IfsSimpleXmlParser`
  If set to true in options table, parser will ignore all attributes in the XML document which are marked as "unsettable".

  See Also:
    Constant Field Values
  (Unpublished)

### SIMPLE_USER_TAG

    public static final java.lang.String SIMPLE_USER_TAG

See Also:
  Constant Field Values
(Unpublished)

### OBJECT_LIST_TAG

    public static final java.lang.String OBJECT_LIST_TAG

See Also:
  Constant Field Values
(Unpublished)

### ARRAY_ELEMENT_TAG

    public static final java.lang.String ARRAY_ELEMENT_TAG

See Also:
  Constant Field Values
(Unpublished)

### CATEGORIES_TAG

    public static final java.lang.String CATEGORIES_TAG

See Also:
  Constant Field Values
(Unpublished)

### FOLDER_PATH_TAG

    public static final java.lang.String FOLDER_PATH_TAG

See Also:
  Constant Field Values
(Unpublished)

### UPDATE_TAG

    public static final java.lang.String UPDATE_TAG

See Also:
  Constant Field Values
(Unpublished)

### OPTIONS_TAG

    public static final java.lang.String OPTIONS_TAG

See Also:
  Constant Field Values
(Unpublished)

### POLICIES_TAG

    public static final java.lang.String POLICIES_TAG

See Also:
  Constant Field Values
(Unpublished)

### POLICY_TAG

    public static final java.lang.String POLICY_TAG

See Also:
  Constant Field Values
(Unpublished)

### MEMBERS_TAG

    public static final java.lang.String MEMBERS_TAG

See Also:
  Constant Field Values
(Unpublished)

### PROPERTIES_TAG

    public static final java.lang.String PROPERTIES_TAG

See Also:
  Constant Field Values
(Unpublished)

### DATATYPE_TAG

    public static final java.lang.String DATATYPE_TAG

See Also:
  Constant Field Values
(Unpublished)

### DOMAINTYPE_ATTRIBUTE

    public static final java.lang.String DOMAINTYPE_ATTRIBUTE

See Also:
  Constant Field Values
(Unpublished)

### PROPERTY_VALUE_TAG

    public static final java.lang.String PROPERTY_VALUE_TAG

See Also:
  Constant Field Values
(Unpublished)

### CONTENT_TAG

    public static final java.lang.String CONTENT_TAG

See Also:
  Constant Field Values
(Unpublished)

### MEDIA_TAG

    public static final java.lang.String MEDIA_TAG

See Also:
  Constant Field Values
(Unpublished)

### FORMAT_TAG

    public static final java.lang.String FORMAT_TAG

See Also:
  Constant Field Values
(Unpublished)

### ATTRIBUTES_TAG

    public static final java.lang.String ATTRIBUTES_TAG

See Also:
  Constant Field Values
(Unpublished)

### ACES_TAG

    public static final java.lang.String ACES_TAG

See Also:
  Constant Field Values
(Unpublished)

### ACCESS_LEVEL_TAG

    public static final java.lang.String ACCESS_LEVEL_TAG

See Also:
  Constant Field Values
(Unpublished)

### GRANTEE_TAG

    public static final java.lang.String GRANTEE_TAG

See Also:
  Constant Field Values
(Unpublished)

### PERMISSIONBUNDLES_TAG

    public static final java.lang.String PERMISSIONBUNDLES_TAG

See Also:
  Constant Field Values
(Unpublished)

### PASSWORD_TAG

    public static final java.lang.String PASSWORD_TAG

See Also:
  Constant Field Values
(Unpublished)

### ACTION_ATTRIBUTE

    public static final java.lang.String ACTION_ATTRIBUTE

See Also:
  Constant Field Values
(Unpublished)

### FORMAT_ATTRIBUTE

    public static final java.lang.String FORMAT_ATTRIBUTE

See Also:
  Constant Field Values
(Unpublished)

### DATATYPE_ATTRIBUTE

    public static final java.lang.String DATATYPE_ATTRIBUTE

See Also:
  Constant Field Values
(Unpublished)

### DEFINITION_ATTRIBUTE

    public static final java.lang.String DEFINITION_ATTRIBUTE

See Also:
  Constant Field Values
(Unpublished)

### CLASSNAME_ATTRIBUTE

    public static final java.lang.String CLASSNAME_ATTRIBUTE

See Also:
  Constant Field Values
(Unpublished)

### REFERENCE_TYPE_ATTRIBUTE

    public static final java.lang.String REFERENCE_TYPE_ATTRIBUTE

See Also:
  Constant Field Values
(Unpublished)

### REFERENCE_BY_PATH

    public static final java.lang.String REFERENCE_BY_PATH

See Also:
  Constant Field Values
(Unpublished)

### REFERENCE_BY_ID

    public static final java.lang.String REFERENCE_BY_ID

See Also:
  Constant Field Values
(Unpublished)

### REFERENCE_BY_NAME

    public static final java.lang.String REFERENCE_BY_NAME

See Also:
  Constant Field Values
(Unpublished)

### REFERENCE_BY_VALUEDEFAULT

    public static final java.lang.String REFERENCE_BY_VALUEDEFAULT

See Also:
  Constant Field Values
(Unpublished)

### VALUEDEFAULT_VALUE_TAG

    public static final java.lang.String VALUEDEFAULT_VALUE_TAG

See Also:
  Constant Field Values
(Unpublished)

### VALUEDOMAIN_VALUE_TAG

    public static final java.lang.String VALUEDOMAIN_VALUE_TAG

See Also:
  Constant Field Values
(Unpublished)

### REFERENCE_BY_EXISTING

    public static final java.lang.String REFERENCE_BY_EXISTING

See Also:
  Constant Field Values
(Unpublished)

### REMOVE_ACTION

    public static final java.lang.String REMOVE_ACTION

See Also:
  Constant Field Values
(Unpublished)

### ADD_ACTION

    public static final java.lang.String ADD_ACTION

See Also:
  Constant Field Values
(Unpublished)

### m_Session

    protected LibrarySession m_Session

  Description copied from class: `IfsSimpleXmlParser`
  The LibrarySession which constructed this XmlParser

  (Unpublished)

### m_Parser

    protected IfsXmlParser m_Parser

  Description copied from class: `IfsSimpleXmlParser`
  The IfsXmlParser

  (Unpublished)

### m_InputStream

    protected java.io.InputStream m_InputStream

  Description copied from class: `IfsSimpleXmlParser`
  The InputStream representing the XML document

  (Unpublished)

### m_Reader

    protected java.io.Reader m_Reader

  Description copied from class: `IfsSimpleXmlParser`
  The Reader representing the XML document

  (Unpublished)

### m_CharacterEncoding

    protected java.lang.String m_CharacterEncoding

  Description copied from class: `IfsSimpleXmlParser`
  The character encoding information stored in tag

  (Unpublished)

Constructor Detail

### IfsSimpleXmlParser

    public IfsSimpleXmlParser(LibrarySession session)

  Constructs a IfsSimpleXmlParser

  Parameters:
    `session` - the LibrarySession
  (Unpublished)

Method Detail

### handleUnknownTag

    protected LibraryObjectDefinition handleUnknownTag(org.w3c.dom.Element unknownElement,
                                                       LibraryObjectDefinition lod)
                                                throws IfsException

  Description copied from class: `IfsSimpleXmlParser`
  Handles an unknown tag.

  Parameters:
    `unknownElement` - the Element which could not be indentified
    `lod` - the LibraryObjectDefinition being processed
  Throws:
    `IfsException` - when operation fails
  (Unpublished)

### parse

    public LibraryObject parse(IfsXmlParser ifsxmlparser,
                               java.io.InputStream stream,
                               ParserCallback callback,
                               java.util.Hashtable options)
                        throws IfsException

  Description copied from interface: `XmlParserInterface`
  Parses the specified InputStream representing an XML document.

  Specified by:
    `parse` in interface `XmlParserInterface`
  Parameters:
    `ifsxmlparser` - this object is the entry point parser and can be used by the content-specific parsers to construct the DOM object, using the Oracle DOM parser
    `stream` - the InputStream
    `callback` - an application object that interacts with the the parsing process; optional, can be null
    `options` - any parser-specific options
  Returns:
    The primary object created. If there is only one top level object then this is returned. If no object is "primary" then null is returned.
  Throws:
    `IfsException` - (IFS-12601) if the operation fails
  (Unpublished)

### parse

    public LibraryObject parse(IfsXmlParser ifsxmlparser,
                               java.io.Reader reader,
                               ParserCallback callback,
                               java.util.Hashtable options)
                        throws IfsException

  Description copied from interface: `XmlParserInterface`
  Parses the specified Reader representing an XML document.

  Specified by:
    `parse` in interface `XmlParserInterface`
  Parameters:
    `ifsxmlparser` - this object is the entry point parser and is used by the content-specific parsers to construct the DOM object, using the Oracle DOM parser
    `reader` - the Reader
    `callback` - an application object that interacts with the the parsing process; optional, can be null
    `options` - any parser-specific options
  Returns:
    The primary object created. If there is only one top level object then this is returned. If no object is "primary" then null is returned.
  Throws:
    `IfsException` - (IFS-12602) if the operation fails
  (Unpublished)

### traverseTree

    protected LibraryObject traverseTree(oracle.xml.parser.v2.XMLDocument doc,
                                         ParserCallback callback,
                                         java.util.Hashtable options)
                                  throws IfsException

  Description copied from class: `IfsSimpleXmlParser`
  Traverses the DOM tree and creates the appropriate LibraryObjects.

  For each LibraryObject created, the implementation must call the appropriate callback methods (if any).

  The creation of LOs is transactional. That is either all LOs will be created or none will. There is an exception to this rule. Creating certain LOs casues a database commit. When this occurs a transaction can no longer be aborted. What this means for traverseTree is once one of these objects is created then all the objects created before that object in the transaction will also be committed. Now, if later in the transaction creating an object fails, the transaction can't be aborted. Forcing the transaction to be commited. Meaning all objects up to the failure will exist. The XML source may no longer be valid considering at least one object in the source already exists. LibraryObjects that cause commits currently are DirectoryUser and ClassObject. The javadoc should be consulted for up-to-date information about a particular LO.

  Parameters:
    `doc` - the XMLDocument (DOM tree created from the Parser's InputStream/Reader) to traverse
    `callback` - an application object that interacts with the parsing process; optional, can be null
    `options` - the Hashtable containing any Parser-specific options for this parser
  Returns:
    The primary object created. If there is only one top level object then this is returned. If no object is "primary" then null is returned.
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### getImplementation

    protected SimpleXmlParserImpl getImplementation(ParserCallback callback,
                                                    java.util.Hashtable options)
                                             throws IfsException

  Description copied from class: `IfsSimpleXmlParser`
  Creates a SimpleXmlParserImpl to parse the document with.

  Throws:
    `IfsException`
  (Unpublished)

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD